/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.artifacts.bundu.bezugswst;

import org.dive4elements.artifactdatabase.data.StateData;
import org.dive4elements.artifacts.Artifact;
import org.dive4elements.artifacts.CallContext;
import org.dive4elements.artifacts.CallMeta;
import org.dive4elements.artifacts.common.utils.XMLUtils;
import org.dive4elements.river.artifacts.resources.Resources;
import org.dive4elements.river.artifacts.states.DefaultState;
import org.dive4elements.river.artifacts.uinfo.salix.ScenarioTypeState;
import org.w3c.dom.Element;

/**
 * @author <a href="mailto:raimund.renkert@intevation.de">Raimund Renkert</a>
 */
public class MissingVolumeSelect extends DefaultState {

    /**
     * The default constructor that initializes an empty State object.
     */
    public MissingVolumeSelect() {
    }

    @Override
    protected Element[] createItems(final XMLUtils.ElementCreator ec, final Artifact artifact, final String name, final CallContext context) {
        final CallMeta meta = context.getMeta();
        final Element[] elements = new Element[1];
        elements[0] = createItem(ec,
                new String[] { Resources.getMsg(meta, "state.bundu.wst.missing_volume.select", "state.bundu.wst.missing_volume.select"), "missing_volume" });

        return elements;
    }

    @Override
    protected String getUIProvider() {
        return "fix.missing_volume_panel"; // generalize?
    }

    @Override
    protected Element createData(final XMLUtils.ElementCreator cr, final Artifact artifact, final StateData data, final CallContext context) {
        return ScenarioTypeState.changeHeaderForCurrentState("state.bundu.wst.missing_volume", data.getName(), cr, context);
    }
}
